﻿using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using Ninject.Activation;

namespace Azure.Toolkit.Azure
{
    public class TableServiceContextProvider : Provider<TableServiceContext>
    {
        private const string ConnectionStringName = "DataConnectionString";

        protected override TableServiceContext CreateInstance(IContext context)
        {
            CloudStorageAccount account = CloudStorageAccount.FromConfigurationSetting(ConnectionStringName);
            return account.CreateCloudTableClient().GetDataServiceContext();
        }
    }
}